
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>smem – Linux 下基于进程和用户的内存占用报告 / iVAN</title>

    <meta name="description" content="smem – Linux 下基于进程和用户的内存占用报告 Linux 系统的内存管理工作中,内存使用情况的监控是十分重要的,在各种 Linux 发行版上你会找到许多这种工具.它们的工作方式多种多样,在这里,我们将会介绍如何安装和使用这样的一个名为 smem 的工具软件. Smem 是一款命令行下的内存使用情况报告工具,它能够给用户提供 Linux 系统下的内存使用的多种报告.和其它传统的内存报告工具不同的是,它有个独特的功能,可以报告 PSS(按比例占用大小Proportional Set Size),这种内存使用量表示方法对于那些在虚拟内存中的应用和">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">smem – Linux 下基于进程和用户的内存占用报告</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Linux 系统的内存管理工作中，内存使用情况的监控是十分重要的，在各种 Linux 发行版上你会找到许多这种工具。它们的工作方式多种多样，在这里，我们将会介绍如何安装和使用这样的一个名为 smem 的工具软件。</p>
<p>Smem 是一款命令行下的内存使用情况报告工具，它能够给用户提供 Linux 系统下的内存使用的多种报告。和其它传统的内存报告工具不同的是，它有个独特的功能，可以报告 PSS（按比例占用大小Proportional Set Size），这种内存使用量表示方法对于那些在虚拟内存中的应用和库更有意义。</p>
<p>已有的传统工具会将目光主要集中于读取 RSS（实际占用大小Resident Set Size），这种方法是以物理内存方案来衡量使用情况的标准方法，但是往往高估了应用程序的内存的使用情况。</p>
<p>PSS 从另一个侧面，通过判定在虚拟内存中的应用和库所使用的“合理分享”的内存，来给出更可信的衡量结果。</p>
<p>你可以阅读此<a href="https://emilics.com/notebook/enblog/p871.html" rel="external nofollow noreferrer">指南 (关于内存的 RSS 和 PSS)</a>了解 Linux 系统中的内存占用，不过现在让我们继续看看 smem 的特点。</p>
<h3>Smem 这一工具的特点</h3>
<ul>
<li>系统概览列表</li>
<li>以进程、映射和用户来显示或者是过滤</li>
<li>从 /proc 文件系统中得到数据</li>
<li>从多个数据源配置显示的条目</li>
<li>可配置输出单位和百分比</li>
<li>易于配置列表表头和汇总</li>
<li>从镜像文件夹或者是压缩的 tar 文件中获得数据快照</li>
<li>内置的图表生成机制</li>
<li>轻量级的捕获工具，可用于嵌入式系统</li>
</ul>
<h3>如何安装 Smem - Linux 下的内存使用情况报告工具</h3>
<p>安装之前，需要确保满足以下的条件：</p>
<ul>
<li>现代内核 (版本号高于 2.6.27)</li>
<li>较新的 Python 版本 (2.4 及以后版本)</li>
<li>可选的 <a href="http://matplotlib.org/index.html" rel="external nofollow noreferrer">matplotlib</a> 库用于生成图表</li>
</ul>
<p>对于当今的大多数的 Linux 发行版而言，内核版本和 Python 的版本都能够满足需要，所以仅需要为生成良好的图表安装 matplotlib 库。</p>
<h4>RHEL, CentOS 和 Fedora</h4>
<p>首先启用 <a href="https://linux.cn/article-2324-1.html" rel="external nofollow noreferrer">EPEL (Extra Packages for Enterprise Linux)</a> 软件源，然后按照下列步骤操作：</p>
<pre>
</pre>
<ol>
<li><code># yum install smem python-matplotlib python-tk</code></li>
</ol>
<h4>Debian 和 Ubuntu</h4>
<pre>
</pre>
<ol>
<li><code>$ sudo apt-get install smem</code></li>
</ol>
<h4>Linux Mint</h4>
<pre>
</pre>
<ol>
<li><code>$ sudo apt-get install smem python-matplotlib python-tk</code></li>
</ol>
<h4>Arch Linux</h4>
<p>使用此 <a href="https://www.archlinux.org/packages/community/i686/smem/" rel="external nofollow noreferrer">AUR 仓库</a>。</p>
<h3>如何使用 Smem – Linux 下的内存使用情况报告工具</h3>
<p>为了查看整个系统所有用户的内存使用情况，运行以下的命令：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem</code></li>
</ol>
<p>监视 Linux 系统中的内存使用情况</p>
<pre>
</pre>
<ol>
<li><code>  PID User     Command                         Swap      USS      PSS      RSS</code></li>
<li><code> 6367 tecmint  cat                                0      100      145     1784</code></li>
<li><code> 6368 tecmint  cat                                0      100      147     1676</code></li>
<li><code> 2864 tecmint  /usr/bin/ck-launch-session         0      144      165     1780</code></li>
<li><code> 7656 tecmint  gnome-pty-helper                   0      156      178     1832</code></li>
<li><code> 5758 tecmint  gnome-pty-helper                   0      156      179     1916</code></li>
<li><code> 1441 root     /sbin/getty -8 38400 tty2          0      152      184     2052</code></li>
<li><code> 1434 root     /sbin/getty -8 38400 tty5          0      156      187     2060</code></li>
<li><code> 1444 root     /sbin/getty -8 38400 tty3          0      156      187     2060</code></li>
<li><code> 1432 root     /sbin/getty -8 38400 tty4          0      156      188     2124</code></li>
<li><code> 1452 root     /sbin/getty -8 38400 tty6          0      164      196     2064</code></li>
<li><code> 2619 root     /sbin/getty -8 38400 tty1          0      164      196     2136</code></li>
<li><code> 3544 tecmint  sh -c /usr/lib/linuxmint/mi        0      212      224     1540</code></li>
<li><code> 1504 root     acpid -c /etc/acpi/events -        0      220      236     1604</code></li>
<li><code> 3311 tecmint  syndaemon -i 0.5 -K -R             0      252      292     2556</code></li>
<li><code> 3143 rtkit    /usr/lib/rtkit/rtkit-daemon        0      300      326     2548</code></li>
<li><code> 1588 root     cron                               0      292      333     2344</code></li>
<li><code> 1589 avahi    avahi-daemon: chroot helpe         0      124      334     1632</code></li>
<li><code> 1523 root     /usr/sbin/irqbalance               0      316      343     2096</code></li>
<li><code>  585 root     upstart-socket-bridge --dae        0      328      351     1820</code></li>
<li><code> 3033 tecmint  /usr/bin/dbus-launch --exit        0      328      360     2160</code></li>
<li><code> 1346 root     upstart-file-bridge --daemo        0      348      371     1776</code></li>
<li><code> 2607 root     /usr/bin/xdm                       0      188      378     2368</code></li>
<li><code> 1635 kernoops /usr/sbin/kerneloops               0      352      386     2684</code></li>
<li><code>  344 root     upstart-udev-bridge --daemo        0      400      427     2132</code></li>
<li><code> 2960 tecmint  /usr/bin/ssh-agent /usr/bin        0      480      485      992</code></li>
<li><code> 3468 tecmint  /bin/dbus-daemon --config-f        0      344      515     3284</code></li>
<li><code> 1559 avahi    avahi-daemon: running [tecm        0      284      517     3108</code></li>
<li><code> 7289 postfix  pickup -l -t unix -u -c            0      288      534     2808</code></li>
<li><code> 2135 root     /usr/lib/postfix/master            0      352      576     2872</code></li>
<li><code> 2436 postfix  qmgr -l -t unix -u                 0      360      606     2884</code></li>
<li><code> 1521 root     /lib/systemd/systemd-logind        0      600      650     3276</code></li>
<li><code> 2222 nobody   /usr/sbin/dnsmasq --no-reso        0      604      669     3288</code></li>
<li><code>....</code></li>
</ol>
<p>当普通用户运行 smem，将会显示由该用户启用的进程的占用情况，其中进程按照 PSS 的值升序排列。</p>
<p>下面的输出为用户 “aaronkilik” 启用的进程的使用情况：</p>
<pre>
</pre>
<ol>
<li><code>$ smem</code></li>
</ol>
<p>监视 Linux 系统中的内存使用情况</p>
<pre>
</pre>
<ol>
<li><code>  PID User     Command                         Swap      USS      PSS      RSS</code></li>
<li><code> 6367 tecmint  cat                                0      100      145     1784</code></li>
<li><code> 6368 tecmint  cat                                0      100      147     1676</code></li>
<li><code> 2864 tecmint  /usr/bin/ck-launch-session         0      144      166     1780</code></li>
<li><code> 3544 tecmint  sh -c /usr/lib/linuxmint/mi        0      212      224     1540</code></li>
<li><code> 3311 tecmint  syndaemon -i 0.5 -K -R             0      252      292     2556</code></li>
<li><code> 3033 tecmint  /usr/bin/dbus-launch --exit        0      328      360     2160</code></li>
<li><code> 3468 tecmint  /bin/dbus-daemon --config-f        0      344      515     3284</code></li>
<li><code> 3122 tecmint  /usr/lib/gvfs/gvfsd                0      656      801     5552</code></li>
<li><code> 3471 tecmint  /usr/lib/at-spi2-core/at-sp        0      708      864     5992</code></li>
<li><code> 3396 tecmint  /usr/lib/gvfs/gvfs-mtp-volu        0      804      914     6204</code></li>
<li><code> 3208 tecmint  /usr/lib/x86_64-linux-gnu/i        0      892     1012     6188</code></li>
<li><code> 3380 tecmint  /usr/lib/gvfs/gvfs-afc-volu        0      820     1024     6396</code></li>
<li><code> 3034 tecmint  //bin/dbus-daemon --fork --        0      920     1081     3040</code></li>
<li><code> 3365 tecmint  /usr/lib/gvfs/gvfs-gphoto2-        0      972     1099     6052</code></li>
<li><code> 3228 tecmint  /usr/lib/gvfs/gvfsd-trash -        0      980     1153     6648</code></li>
<li><code> 3107 tecmint  /usr/lib/dconf/dconf-servic        0     1212     1283     5376</code></li>
<li><code> 6399 tecmint  /opt/google/chrome/chrome -        0      144     1409    10732</code></li>
<li><code> 3478 tecmint  /usr/lib/x86_64-linux-gnu/g        0     1724     1820     6320</code></li>
<li><code> 7365 tecmint  /usr/lib/gvfs/gvfsd-http --        0     1352     1884     8704</code></li>
<li><code> 6937 tecmint  /opt/libreoffice5.0/program        0     1140     2328     5040</code></li>
<li><code> 3194 tecmint  /usr/lib/x86_64-linux-gnu/p        0     1956     2405    14228</code></li>
<li><code> 6373 tecmint  /opt/google/chrome/nacl_hel        0     2324     2541     8908</code></li>
<li><code> 3313 tecmint  /usr/lib/gvfs/gvfs-udisks2-        0     2460     2754     8736</code></li>
<li><code> 3464 tecmint  /usr/lib/at-spi2-core/at-sp        0     2684     2823     7920</code></li>
<li><code> 5771 tecmint  ssh -p 4521 tecmnt765@212.7        0     2544     2864     6540</code></li>
<li><code> 5759 tecmint  /bin/bash                          0     2416     2923     5640</code></li>
<li><code> 3541 tecmint  /usr/bin/python /usr/bin/mi        0     2584     3008     7248</code></li>
<li><code> 7657 tecmint  bash                               0     2516     3055     6028</code></li>
<li><code> 3127 tecmint  /usr/lib/gvfs/gvfsd-fuse /r        0     3024     3126     8032</code></li>
<li><code> 3205 tecmint  mate-screensaver                   0     2520     3331    18072</code></li>
<li><code> 3171 tecmint  /usr/lib/mate-panel/notific        0     2860     3495    17140</code></li>
<li><code> 3030 tecmint  x-session-manager                  0     4400     4879    17500</code></li>
<li><code> 3197 tecmint  mate-volume-control-applet         0     3860     5226    23736</code></li>
<li><code>...</code></li>
</ol>
<p>使用 smem 时还有一些参数可以选用，例如当查看整个系统的内存占用情况，运行以下的命令：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem -w</code></li>
</ol>
<p>监视 Linux 系统中的内存使用情况</p>
<pre>
</pre>
<ol>
<li><code>Area                           Used      Cache   Noncache</code></li>
<li><code>firmware/hardware                 0          0          0</code></li>
<li><code>kernel image                      0          0          0</code></li>
<li><code>kernel dynamic memory       1425320    1291412     133908</code></li>
<li><code>userspace memory            2215368     451608    1763760</code></li>
<li><code>free memory                 4424936    4424936          0</code></li>
</ol>
<p>如果想要查看每一个用户的内存使用情况，运行以下的命令：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem -u</code></li>
</ol>
<p>Linux 下以用户为单位监控内存占用情况</p>
<pre>
</pre>
<ol>
<li><code>User     Count     Swap      USS      PSS      RSS</code></li>
<li><code>rtkit        1        0      300      326     2548</code></li>
<li><code>kernoops     1        0      352      385     2684</code></li>
<li><code>avahi        2        0      408      851     4740</code></li>
<li><code>postfix      2        0      648     1140     5692</code></li>
<li><code>messagebus     1        0     1012     1173     3320</code></li>
<li><code>syslog       1        0     1396     1419     3232</code></li>
<li><code>www-data     2        0     5100     6572    13580</code></li>
<li><code>mpd          1        0     7416     8302    12896</code></li>
<li><code>nobody       2        0     4024    11305    24728</code></li>
<li><code>root        39        0   323876   353418   496520</code></li>
<li><code>tecmint     64        0  1652888  1815699  2763112</code></li>
</ol>
<p>你也可以按照映射显示内存使用情况：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem -m</code></li>
</ol>
<p>Linux 下以映射为单位监控内存占用情况</p>
<pre>
</pre>
<ol>
<li><code>Map                                       PIDs   AVGPSS      PSS</code></li>
<li><code>/dev/fb0                                     1        0        0</code></li>
<li><code>/home/tecmint/.cache/fontconfig/7ef2298f    18        0        0</code></li>
<li><code>/home/tecmint/.cache/fontconfig/c57959a1    18        0        0</code></li>
<li><code>/home/tecmint/.local/share/mime/mime.cac    15        0        0</code></li>
<li><code>/opt/google/chrome/chrome_material_100_p     9        0        0</code></li>
<li><code>/opt/google/chrome/chrome_material_200_p     9        0        0</code></li>
<li><code>/usr/lib/x86_64-linux-gnu/gconv/gconv-mo    41        0        0</code></li>
<li><code>/usr/share/icons/Mint-X-Teal/icon-theme.    15        0        0</code></li>
<li><code>/var/cache/fontconfig/0c9eb80ebd1c36541e    20        0        0</code></li>
<li><code>/var/cache/fontconfig/0d8c3b2ac0904cb8a5    20        0        0</code></li>
<li><code>/var/cache/fontconfig/1ac9eb803944fde146    20        0        0</code></li>
<li><code>/var/cache/fontconfig/3830d5c3ddfd5cd38a    20        0        0</code></li>
<li><code>/var/cache/fontconfig/385c0604a188198f04    20        0        0</code></li>
<li><code>/var/cache/fontconfig/4794a0821666d79190    20        0        0</code></li>
<li><code>/var/cache/fontconfig/56cf4f4769d0f4abc8    20        0        0</code></li>
<li><code>/var/cache/fontconfig/767a8244fc0220cfb5    20        0        0</code></li>
<li><code>/var/cache/fontconfig/8801497958630a81b7    20        0        0</code></li>
<li><code>/var/cache/fontconfig/99e8ed0e538f840c56    20        0        0</code></li>
<li><code>/var/cache/fontconfig/b9d506c9ac06c20b43    20        0        0</code></li>
<li><code>/var/cache/fontconfig/c05880de57d1f5e948    20        0        0</code></li>
<li><code>/var/cache/fontconfig/dc05db6664285cc2f1    20        0        0</code></li>
<li><code>/var/cache/fontconfig/e13b20fdb08344e0e6    20        0        0</code></li>
<li><code>/var/cache/fontconfig/e7071f4a29fa870f43    20        0        0</code></li>
<li><code>....</code></li>
</ol>
<p>还有其它的选项可以筛选 smem 的输出，下面将会举两个例子。</p>
<p>要按照用户名筛选输出的信息，使用 <code>-u</code> 或者是 <code>--userfilter="regex"</code> 选项，就像下面的命令这样：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem -u</code></li>
</ol>
<p>按照用户报告内存使用情况</p>
<pre>
</pre>
<ol>
<li><code>User     Count     Swap      USS      PSS      RSS</code></li>
<li><code>rtkit        1        0      300      326     2548</code></li>
<li><code>kernoops     1        0      352      385     2684</code></li>
<li><code>avahi        2        0      408      851     4740</code></li>
<li><code>postfix      2        0      648     1140     5692</code></li>
<li><code>messagebus   1        0     1012     1173     3320</code></li>
<li><code>syslog       1        0     1400     1423     3236</code></li>
<li><code>www-data     2        0     5100     6572    13580</code></li>
<li><code>mpd          1        0     7416     8302    12896</code></li>
<li><code>nobody       2        0     4024    11305    24728</code></li>
<li><code>root        39        0   323804   353374   496552</code></li>
<li><code>tecmint     64        0  1708900  1871766  2819212</code></li>
</ol>
<p>要按照进程名称筛选输出信息，使用 <code>-P</code> 或者是 <code>--processfilter="regex"</code> 选项，就像下面的命令这样：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem --processfilter="firefox"</code></li>
</ol>
<p>按照进程名称报告内存使用情况</p>
<pre>
</pre>
<ol>
<li><code>PID  User     Command                         Swap      USS      PSS      RSS</code></li>
<li><code>9212 root     sudo smem --processfilter=f        0     1172     1434     4856</code></li>
<li><code>9213 root     /usr/bin/python /usr/bin/sm        0     7368     7793    11984</code></li>
<li><code>4424 tecmint  /usr/lib/firefox/firefox           0   931732   937590   961504</code></li>
</ol>
<p>输出的格式有时候也很重要，smem 提供了一些帮助您格式化内存使用报告的参数，我们将举出几个例子。</p>
<p>设置哪些列在报告中，使用 -c 或者是 --columns 选项，就像下面的命令这样：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem -c "name user pss rss"</code></li>
</ol>
<p>按列报告内存使用情况</p>
<pre>
</pre>
<ol>
<li><code>Name                     User          PSS      RSS</code></li>
<li><code>cat                      tecmint       145     1784</code></li>
<li><code>cat                      tecmint       147     1676</code></li>
<li><code>ck-launch-sessi          tecmint       165     1780</code></li>
<li><code>gnome-pty-helpe          tecmint       178     1832</code></li>
<li><code>gnome-pty-helpe          tecmint       179     1916</code></li>
<li><code>getty                    root          184     2052</code></li>
<li><code>getty                    root          187     2060</code></li>
<li><code>getty                    root          187     2060</code></li>
<li><code>getty                    root          188     2124</code></li>
<li><code>getty                    root          196     2064</code></li>
<li><code>getty                    root          196     2136</code></li>
<li><code>sh                       tecmint       224     1540</code></li>
<li><code>acpid                    root          236     1604</code></li>
<li><code>syndaemon                tecmint       296     2560</code></li>
<li><code>rtkit-daemon             rtkit         326     2548</code></li>
<li><code>cron                     root          333     2344</code></li>
<li><code>avahi-daemon             avahi         334     1632</code></li>
<li><code>irqbalance               root          343     2096</code></li>
<li><code>upstart-socket-          root          351     1820</code></li>
<li><code>dbus-launch              tecmint       360     2160</code></li>
<li><code>upstart-file-br          root          371     1776</code></li>
<li><code>xdm                      root          378     2368</code></li>
<li><code>kerneloops               kernoops      386     2684</code></li>
<li><code>upstart-udev-br          root          427     2132</code></li>
<li><code>ssh-agent                tecmint       485      992</code></li>
<li><code>...</code></li>
</ol>
<p>也可以调用 <code>-p</code> 选项以百分比的形式报告内存使用情况，就像下面的命令这样：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem -p</code></li>
</ol>
<p>按百分比报告内存使用情况</p>
<pre>
</pre>
<ol>
<li><code>  PID User     Command                         Swap      USS      PSS      RSS</code></li>
<li><code> 6367 tecmint  cat                            0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 6368 tecmint  cat                            0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 9307 tecmint  sh -c { sudo /usr/lib/linux    0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 2864 tecmint  /usr/bin/ck-launch-session     0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 3544 tecmint  sh -c /usr/lib/linuxmint/mi    0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 5758 tecmint  gnome-pty-helper               0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 7656 tecmint  gnome-pty-helper               0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 1441 root     /sbin/getty -8 38400 tty2      0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 1434 root     /sbin/getty -8 38400 tty5      0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 1444 root     /sbin/getty -8 38400 tty3      0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 1432 root     /sbin/getty -8 38400 tty4      0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 1452 root     /sbin/getty -8 38400 tty6      0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 2619 root     /sbin/getty -8 38400 tty1      0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 1504 root     acpid -c /etc/acpi/events -    0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 3311 tecmint  syndaemon -i 0.5 -K -R         0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 3143 rtkit    /usr/lib/rtkit/rtkit-daemon    0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 1588 root     cron                           0.00%    0.00%    0.00%    0.03%</code></li>
<li><code> 1589 avahi    avahi-daemon: chroot helpe     0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 1523 root     /usr/sbin/irqbalance           0.00%    0.00%    0.00%    0.03%</code></li>
<li><code>  585 root     upstart-socket-bridge --dae    0.00%    0.00%    0.00%    0.02%</code></li>
<li><code> 3033 tecmint  /usr/bin/dbus-launch --exit    0.00%    0.00%    0.00%    0.03%</code></li>
<li><code>....</code></li>
</ol>
<p>下面的命令将会在输出的最后输出一行汇总信息：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem -t</code></li>
</ol>
<p>报告内存占用合计</p>
<pre>
</pre>
<ol>
<li><code>  PID User     Command                         Swap      USS      PSS      RSS</code></li>
<li><code> 6367 tecmint  cat                                0      100      139     1784</code></li>
<li><code> 6368 tecmint  cat                                0      100      141     1676</code></li>
<li><code> 9307 tecmint  sh -c { sudo /usr/lib/linux        0       96      158     1508</code></li>
<li><code> 2864 tecmint  /usr/bin/ck-launch-session         0      144      163     1780</code></li>
<li><code> 3544 tecmint  sh -c /usr/lib/linuxmint/mi        0      108      170     1540</code></li>
<li><code> 5758 tecmint  gnome-pty-helper                   0      156      176     1916</code></li>
<li><code> 7656 tecmint  gnome-pty-helper                   0      156      176     1832</code></li>
<li><code> 1441 root     /sbin/getty -8 38400 tty2          0      152      181     2052</code></li>
<li><code> 1434 root     /sbin/getty -8 38400 tty5          0      156      184     2060</code></li>
<li><code> 1444 root     /sbin/getty -8 38400 tty3          0      156      184     2060</code></li>
<li><code> 1432 root     /sbin/getty -8 38400 tty4          0      156      185     2124</code></li>
<li><code> 1452 root     /sbin/getty -8 38400 tty6          0      164      193     2064</code></li>
<li><code> 2619 root     /sbin/getty -8 38400 tty1          0      164      193     2136</code></li>
<li><code> 1504 root     acpid -c /etc/acpi/events -        0      220      232     1604</code></li>
<li><code> 3311 tecmint  syndaemon -i 0.5 -K -R             0      260      298     2564</code></li>
<li><code> 3143 rtkit    /usr/lib/rtkit/rtkit-daemon        0      300      324     2548</code></li>
<li><code> 1588 root     cron                               0      292      326     2344</code></li>
<li><code> 1589 avahi    avahi-daemon: chroot helpe         0      124      332     1632</code></li>
<li><code> 1523 root     /usr/sbin/irqbalance               0      316      340     2096</code></li>
<li><code>  585 root     upstart-socket-bridge --dae        0      328      349     1820</code></li>
<li><code> 3033 tecmint  /usr/bin/dbus-launch --exit        0      328      359     2160</code></li>
<li><code> 1346 root     upstart-file-bridge --daemo        0      348      370     1776</code></li>
<li><code> 2607 root     /usr/bin/xdm                       0      188      375     2368</code></li>
<li><code> 1635 kernoops /usr/sbin/kerneloops               0      352      384     2684</code></li>
<li><code>  344 root     upstart-udev-bridge --daemo        0      400      426     2132</code></li>
<li><code>.....</code></li>
<li><code>-------------------------------------------------------------------------------</code></li>
<li><code>  134 11                                          0  2171428  2376266  3587972</code></li>
</ol>
<p>另外，smem 也提供了选项以图形的形式报告内存的使用情况，我们将会在下一小节深入介绍。</p>
<p>比如，你可以生成一张进程的 PSS 和 RSS 值的条状图。在下面的例子中，我们会生成属于 root 用户的进程的内存占用图。</p>
<p>纵坐标为每一个进程的 PSS 和 RSS 值，横坐标为 root 用户的所有进程（的 ID）：</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem --userfilter="root" --bar pid -c"pss rss"</code></li>
</ol>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNjA4LzE0LzA5MzMzOWZoZ3NoZ2lrb21sbWdzbW0ucG5n.jpg"></p>
<p><em>Linux Memory Usage in PSS and RSS Values</em></p>
<p>也可以生成进程及其 PSS 和 RSS 占用量的饼状图。以下的命令将会输出一张 root 用户的所有进程的饼状图。</p>
<p><code>--pie</code> name 意思为以各个进程名字为标签，<code>-s</code> 选项用来以 PSS 的值排序。</p>
<pre>
</pre>
<ol>
<li><code>$ sudo smem --userfilter="root" --pie name -s pss</code></li>
</ol>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNjA4LzE0LzA5MzM0MGhnOHpyc3h3Z2c5c3czbTIucG5n.jpg"></p>
<p><em>Linux Memory Consumption by Processes</em></p>
<p>原文发布时间为：2016-08-14</p>
<p>本文来自合作伙伴“Linux中国”</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 05:46:05</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>, <a href="https://www.iamivan.net/tag/rss/" title="RSS">RSS</a>, <a href="https://www.iamivan.net/tag/cache/" title="Cache">Cache</a>, <a href="https://www.iamivan.net/tag/postfix/" title="postfix">postfix</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>smem – Linux 下基于进程和用户的内存占用报告的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkG8L7p.html" rel="bookmark">Linux下VsFTP和ProFTP用户管理高级技巧 之一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://chenguang.blog.51cto.com/350944/217853 Linux下VsFTP和ProFTP用户管理高级技巧       FTP服务时互联网上比较古老的一种应用,至今Interner应用面非常广泛,但令管理员头痛不已的是其用户管理,既多且杂,如何解决这一问题呢?使用MySQL与ProFTP或VsFTP软件结合可以搭建一个高效.稳定且集中管理的FTP服务器.本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqyvdp.html" rel="bookmark">linux下基于C语言的信号编程实例&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了linux下基于C语言的信号编程方法.分享给大家供大家参考.具体如下: #include &lt;stdio.h&gt; #include &lt;unistd.h&gt; #include &lt;stdlib.h&gt; #include &lt;unistd.h&gt; #include &lt;signal.h&gt; void sig_handler(int sig_no, siginfo_t *info, void *ctext){ printf(&quot;receive si			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKD2nz.html" rel="bookmark">Python实现Linux下守护进程的编写方法&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Python实现Linux下守护进程的编写方法,分享给大家供大家参考,相信对于大家的Python程序设计会起到一定的帮助作用.具体方法如下: 1. 调用fork()以便父进程可以退出,这样就将控制权归还给运行你程序的命令行或shell程序.需要这一步以便保证新进程不是一个进程组头领进程(process group leader).下一步,'setsid()',会因为你是进程组头领进程而失败.进程调用fork函数时,操作系统会新建一个子进程,它本质上与父进程完全相同.子进程从父进程继			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9XZ84b.html" rel="bookmark">解决Linux下php-fpm进程过多导致内存耗尽问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近,发现个人博客的Linux服务器,数据库服务经常挂掉,导致需要重启,才能正常访问,极其恶心,于是决心开始解决问题,解放我的时间和精力(我可不想经常出问题,然后人工重启,费力费时). 分析问题 发现问题以后,首先使用 free -m 指令查看当前服务器执行状况: 可以看到我的服务器内存是2G的,但是目前可用内存只剩下70M,内存使用率高达92%,很有可能是内存使用率过高导致数据库服务挂断. 继续看详细情况,使用 top 指令: 然后再看指令输出结果中详细列出的进程情况,重点关注第10列内存使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVLBWnM.html" rel="bookmark">云环境下基于属性的用户权限管理研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				云环境下基于属性的用户权限管理研究 李拴保 范乃英 傅建明 祁慧敏 刘芊 用户权限分配是云计算服务的重要难题之一,提出了一种基于属性的用户权限管理方案.该方案以云服务中的新用户密钥分配为研究对象,论述了多方协同的用户签名验证解密管理机制,数据所有者和授权者共同选择属性集,数据所有者基于属性集定义密文访问结构,从而用户只有通过授权者认证才能获得解密密钥,达到用户权限升级与降级同步管理的目的.另外,本方案以群属性集更新为中心设计CP-ABE群签名验证机制,令数据所有者.用户和授权者组成群;基于群和自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyg4Nz.html" rel="bookmark">请问测试linux下某个jsp站点cpu和内存占用率代码怎么写？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 请问测试linux下某个jsp站点cpu和内存占用率代码怎么写?谢谢! 解决方案 解决方案二:up解决方案三:Up解决方案四:Up解决方案五:http://www.diybl.com/course/4_webprogram/jsp/jsp_js/20090212/155296_3.html看看这个~·解决方案六:思路就是调用linux下的命令然后分析输出的结果.解决方案七:继续问解决方案八:Runtimerun=Runtime.getRuntime();Processpro=run.e			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baBg2qM.html" rel="bookmark">NetHogs&mdash;&mdash;Linux下按进程实时统计网络带宽利用率</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网上有很多适用于Linux操作系统的开源网络监视工具.比如说,你可以用命令iftop来检查带宽使用情况. netstat用来查看接口统计报告,还有top监控系统当前运行进程.但是如果你想要找一个能够按进程实时统计网络带宽利用率,那么NetHogs就是你所需要的唯一工具. 1 NetHogs – 网络带宽监控 什么是NetHogs? NetHogs 是一个开源的命令行工具(类似于Linux的top命令),用来按进程或程序实时统计网络带宽使用率. 来自NetHogs项目网站: NetHogs是一个小			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgPO78p.html" rel="bookmark">Linux下查看进程打开的文件句柄数和如何修改</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				修改文件句柄数在Linux下,我们使用ulimit -n 命令可以看到单个进程能够打开的最大文件句柄数量(socket连接也算在里面).系统默认值1024.     对于一般的应用来说(象Apache.系统进程)1024完全足够使用.但是如何象squid.mysql.java等单进程处理大量请求的应用来说就有 点捉襟见肘了.如果单个进程打开的文件句柄数量超过了系统定义的值,就会提到&quot;too many files open&quot;的错误提示.如何知道当前进程打开了多少个文件句柄呢?下面一段小脚			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVGdDBb.html" rel="bookmark">Linux下用Valgrind做检查&lpar;防止内存泄露&rpar;&lowbar;C 语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用C/C++开发其中最令人头疼的一个问题就是内存管理,有时候为了查找一个内存泄漏或者一个内存访问越界,需要要花上好几天时间,如果有一款工具能够帮助我们做这件事情就好了,valgrind正好就是这样的一款工具. Valgrind是一款基于模拟linux下的程序调试器和剖析器的软件套件,可以运行于x86, amd64和ppc32架构上.valgrind包含一个核心,它提供一个虚拟的CPU运行程序,还有一系列的工具,它们完成调试,剖析和一些类似的任务.valgrind是高度模块化的,所以开发人员或者用			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zO0r5b.html" rel="bookmark" class="title">菜鸟调试手记一（sql server 中文问题）</a>
					<div>
						server|问题|中文 学习 Java 看到了 Jdbc 一章 本人就会使用 SQL Server 所以就找了一个微软的 SQL Server2000 Jdbc Driver.(在坛子上请教了多位大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdkr2M.html" rel="bookmark" class="title">NET高级开发一：用VB&period;net&plus;ADO&period;NET&plus;SQLServer开发三层架构的运用程序</a>
					<div>
						ado|server|sqlserver|程序|高级|架构      NET高级开发一:用VB.net+ADO.Net+SQL Server开发三层架构的运用程序 一:什么是三层体系结构:    三层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlaAVp.html" rel="bookmark" class="title">ASP中数据库操作中游标和加锁方式</a>
					<div>
						数据|数据库|游标 一般而言,下面是个典型的打开数据库的过程. &lt; % '游标类型 Const adOpenForwardOnly = 0 Const adOpenKeyset = 1 Cons ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bovlvz.html" rel="bookmark" class="title">权衡利弊之后再去截获别人的品牌词方能有所获</a>
					<div>
						截获流量我想做SEO有段时间的人都会知道,不知道大家有没有这样做过呢?这样做到底是好呢,还是不好呢?今天就来给大家分析一下大家听完之后再去判断一下自己是不是需要花这些精力去做这件事,也就是说值不值?  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlyWmb.html" rel="bookmark" class="title">Word 2010中将命令按钮添加到工具栏</a>
					<div>
						Word 2010文档窗口中的&quot;快速访问工具栏&quot;用于放置命令按钮,使用户快速启动经常使用的命令.默认情况下,&quot;快速访问工具栏&quot;中只有数量较少的命令,用户可以根据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ja2Zb.html" rel="bookmark" class="title">C&plus;&plus;类静态数据成员与类静态成员函数</a>
					<div>
						在没有讲述本章内容之前如果我们想要在一个范围内共享某一个数据,那么我们会设立全局对象,但面向对象的程序是由对象构成的,我们如何才能在类范围内共享数据呢? 这个问题便是本章的重点: 声明为static的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRawOz.html" rel="bookmark" class="title">搜狗输入法怎样进行翻页选字？</a>
					<div>
						  搜狗拼音输入法默认的翻页键是&quot;逗号(,)句号(.)&quot;,即输入拼音后,按句号(.)进行向下翻页选字,相当于PageDown键,找到所选的字后,按其相对应的数字键即可输入.我们推荐 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o5Rkb.html" rel="bookmark" class="title">DIY组装电脑排线怎么安装</a>
					<div>
						  对于第一次组装电脑的新手来说,可能遇到的一大难题就是怎么接好主机前置机箱的排线问题.我们知道在组装的时候需要插入多个排线,如开关排线.USB排线.重启排线.音频排线等等.那么对于小白来说究竟怎么样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7NrVb.html" rel="bookmark" class="title">mfc-MFC全局变量的设定？！</a>
					<div>
						问题描述 MFC全局变量的设定?! 创立了一个mfc工程A. 我在A.h中定义了一个数据结构类class B. 现在想声明一个B对象b,用于存放待管理的数据,要使所有的.cpp文件都能引用这个对象b, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOl0a8b.html" rel="bookmark" class="title">电脑系统-w7 cmd显示不了中文字符</a>
					<div>
						问题描述 w7 cmd显示不了中文字符 怎么破.一打开最开头的什么什么版权所有都不显示中文都变空格了 解决方案 切换下输入法看看.再不行重启下.是不是安装了不兼容的输入法. 解决方案二: cmd是不是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXwl1z.html" rel="bookmark" class="title">关于粒子编辑器，初学者求帮忙</a>
					<div>
						问题描述 关于粒子编辑器,初学者求帮忙 粒子编辑器下载好之后.点击哪一个是打开,初学者求求大家帮帮忙关于粒子编辑器,粒子编辑器下载好之后.点击哪一个是打开,打开之后可以进行编辑然后可以到处成.plis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M945q3b.html" rel="bookmark" class="title">企业网站栏目应该如何选择</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 哪家的企业网站加这几个栏目了?越来越多的企业网站现在已经非常重视优化与推广了,大家都在追求推广与优化的结果,可是很重要的一点,许多企业网站都忽视了一个很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0RkK0z.html" rel="bookmark" class="title">《LDA漫游指南》&mdash;&mdash;第2章 前置知识</a>
					<div>
						第2章 前置知识 LDA漫游指南 本章所描述的工具和线索在后期LDA算法的采样公式推导中会全部明了.关于为什么需要使用这些知识要素,这里面有很长的一段历史渊源,比如在概率论和数理统计中,gamma函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0P9QM.html" rel="bookmark" class="title">层次遍历用队列打印树，是怎么摆放成树的形状的</a>
					<div>
						问题描述 层次遍历用队列打印树,是怎么摆放成树的形状的 层次遍历用队列打印出树,树是如何摆放的,就是如何才能摆放出树的形状,要用文字叙述,不要代码,不要代码 解决方案 树的层次遍历树的层次遍历树 层次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjkXGM.html" rel="bookmark" class="title">界面-关于QT点击button无响应的问题</a>
					<div>
						问题描述 关于QT点击button无响应的问题 请教一下大神,我在做课程设计,要做界面第一次接触QT.做的是一个简单的0-1背包问题,要求用蛮力法和动态规划法两种方法.先用VS写的代码,两种算法都能得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod4JVM.html" rel="bookmark" class="title">沉寂已久的C2C领域再起波澜</a>
					<div>
						最近,拍拍网重新登台亮相,并且首次对外公布了新拍拍网在用户分享.流量分发.平台规则等多个方面的举措,甚至还放言&quot;3至5年内不会将盈利作为目的&quot;. 根据消息,与微信的连动将会成为新拍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnBW9M.html" rel="bookmark" class="title">Java 7&colon; 全面教程-1&period;2 Java代码规格</a>
					<div>
						1.2 Java代码规格 写正确的可运行的Java程序固然重要,但是写出的代码方便阅读和维护也是相当重要的.普遍相信一个软件80%的时间都花在维护上.而且,程序员的变动率非常的高,所以很有可能是别人在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNgPKM.html" rel="bookmark" class="title">hibernate search 什么query是sql里的in操作</a>
					<div>
						问题描述 由于查找的条件是in(a,b,c,d)不知道hibernatesearch里什么query支持. 解决方案 解决方案二:是说in里面传递参数么?int[]a={1,2,3,4};String ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlBBAp.html" rel="bookmark" class="title">CSS实现DIV内容居中&lpar;垂直&rpar;方法</a>
					<div>
						首先,要有一个概念:凡是 table 布局可以实现的,CSS 一定可以实现.CSS 可以实现的,table 未必能做到. 现在来几个例子: 一.单行内容的居中只考虑单行是最简单的,无论是否给容器固定高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm10Dp.html" rel="bookmark" class="title">浅谈COOKIE和SESSION区别&lowbar;php技巧</a>
					<div>
						一.cookie介绍 cookie 常用于识别用户.cookie 是服务器留在用户计算机中的小文件.每当相同的计算机通过浏览器请求页面时,它同时会发送 cookie.通过 PHP,您能够创建并取回 c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWmE2z.html" rel="bookmark" class="title">thinkphp在模型中自动完成session赋值示例代码&lowbar;php技巧</a>
					<div>
						相信用过thinkphp的用户都知道thinkphp的模型可以完成很多辅助功能,比如自动验证.自动完成等,今天在开发中遇到自动完成中需要获取session值然后自动赋值的功能,具体看代码: class ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWoOkz.html" rel="bookmark" class="title">20个非常棒的 jQuery 幻灯片插件和教程分享&lowbar;jquery</a>
					<div>
						滑块和幻灯片效果是常用的内容展示方式之一,这是一种在有限的网页空间内展示系列项目时非常好的方法.今天这篇文章就与大家分享20个非常棒的 jQuery 幻灯片插件和教程. &gt; Slider Gal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEAg5z.html" rel="bookmark" class="title">js将iframe中控件的值传到主页面控件中的实现方法&lowbar;javascript技巧</a>
					<div>
						现在来看一下代码的实现,首先来看一个主界面的代码 复制代码 代码如下: &lt;html&gt;     &lt;head&gt;         &lt;script type=&quot;text ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q5aWp.html" rel="bookmark" class="title">java中的一些简单概念问题搞不清希望大家帮忙&period;</a>
					<div>
						问题描述 什么是引用?什么是对象?什么是实力化? 解决方案 举个通俗的例子,假如老板让你负责一个项目.首先你要召集一些人手,这时你从HR那里获得一些对你有用的人的联系方式,比如手机.QQ等方式,这些可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zen7yOb.html" rel="bookmark" class="title">凭借seo垂直电商能够杀出活路？</a>
					<div>
						当前电商横行时代,天猫,淘宝,京东,当当...等等这些巨头电商网站,涉及的产品已经基本可以满足大众的需求了.但时,很多垂直电商还是像雨后春笋般的快速成长,由此可知,还是很多人想从电商细缝中争取到一杯羹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXno0z.html" rel="bookmark" class="title">单点登录 调用一个其他公司提供的服务器的方法和内容</a>
					<div>
						问题描述 本人是学生菜鸟,现在想要做一个网站,在这个网站调用另一个公司提供的服务器,这个服务器只给了URL接口和ResponseXMLSchema,这个服务器需要登录才能访问.该怎么做,不胜感激!!最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zennWNb.html" rel="bookmark" class="title">C&num;中使用return的问题。</a>
					<div>
						问题描述 请问如何结束某个过程.例:publicvoidItem_SaveData(){if(tabControl1.SelectedTab==tabPage1){//验证数据if(fS_TextBo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7gy5p.html" rel="bookmark" class="title">使用DirectoryInfo绑定数据，然后分页的问题。</a>
					<div>
						问题描述 代码如下,绑定后,如果一次性显示,没有问题,但是如果我把pagesize=2,那么显示就有问题了.每次都只是显示同样的图片.为什么?麻烦通俗直观的解释.谢谢&lt;%@PageLanguag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9NmnKp.html" rel="bookmark" class="title">李亚鹏窦靖童参加志愿者晚会父女情深献爱心</a>
					<div>
						李亚鹏窦靖童亲密耳语(1/11张) 28日早餐后,李亚鹏和志愿者前往达里湖景区克什克腾旗达来诺日镇总校做扶贫助学活动.当晚入住阿斯哈图石林景区蒙古包,与志愿者一起参加篝火晚会庆祝赤峰市救助活动结束.[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn43GWb.html" rel="bookmark" class="title">离别海润光伏：杨怀进的&OpenCurlyDoubleQuote;轮回怪圈&rdquo;</a>
					<div>
						似乎又是一场轮回,在进入海润光伏六年后,52岁的杨怀进再次选择转身离去,正如之前他的光伏经历一样. 不久之前,海润光伏发布公告称,公司董事长杨怀近辞职,在海润光伏的公告中,对于杨怀进辞任董事长的原因, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
